package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DeleteAlertTemplate invokes the arms.DeleteAlertTemplate API synchronously
func (client *Client) DeleteAlertTemplate(request *DeleteAlertTemplateRequest) (response *DeleteAlertTemplateResponse, err error) {
	response = CreateDeleteAlertTemplateResponse()
	err = client.DoAction(request, response)
	return
}

// DeleteAlertTemplateWithChan invokes the arms.DeleteAlertTemplate API asynchronously
func (client *Client) DeleteAlertTemplateWithChan(request *DeleteAlertTemplateRequest) (<-chan *DeleteAlertTemplateResponse, <-chan error) {
	responseChan := make(chan *DeleteAlertTemplateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DeleteAlertTemplate(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DeleteAlertTemplateWithCallback invokes the arms.DeleteAlertTemplate API asynchronously
func (client *Client) DeleteAlertTemplateWithCallback(request *DeleteAlertTemplateRequest, callback func(response *DeleteAlertTemplateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DeleteAlertTemplateResponse
		var err error
		defer close(result)
		response, err = client.DeleteAlertTemplate(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DeleteAlertTemplateRequest is the request struct for api DeleteAlertTemplate
type DeleteAlertTemplateRequest struct {
	*requests.RpcRequest
	Id          requests.Integer `position:"Query" name:"Id"`
	ProxyUserId string           `position:"Query" name:"ProxyUserId"`
}

// DeleteAlertTemplateResponse is the response struct for api DeleteAlertTemplate
type DeleteAlertTemplateResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
}

// CreateDeleteAlertTemplateRequest creates a request to invoke DeleteAlertTemplate API
func CreateDeleteAlertTemplateRequest() (request *DeleteAlertTemplateRequest) {
	request = &DeleteAlertTemplateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "DeleteAlertTemplate", "arms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDeleteAlertTemplateResponse creates a response to parse from DeleteAlertTemplate response
func CreateDeleteAlertTemplateResponse() (response *DeleteAlertTemplateResponse) {
	response = &DeleteAlertTemplateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
