package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetIntegrationToken invokes the arms.GetIntegrationToken API synchronously
func (client *Client) GetIntegrationToken(request *GetIntegrationTokenRequest) (response *GetIntegrationTokenResponse, err error) {
	response = CreateGetIntegrationTokenResponse()
	err = client.DoAction(request, response)
	return
}

// GetIntegrationTokenWithChan invokes the arms.GetIntegrationToken API asynchronously
func (client *Client) GetIntegrationTokenWithChan(request *GetIntegrationTokenRequest) (<-chan *GetIntegrationTokenResponse, <-chan error) {
	responseChan := make(chan *GetIntegrationTokenResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetIntegrationToken(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetIntegrationTokenWithCallback invokes the arms.GetIntegrationToken API asynchronously
func (client *Client) GetIntegrationTokenWithCallback(request *GetIntegrationTokenRequest, callback func(response *GetIntegrationTokenResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetIntegrationTokenResponse
		var err error
		defer close(result)
		response, err = client.GetIntegrationToken(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetIntegrationTokenRequest is the request struct for api GetIntegrationToken
type GetIntegrationTokenRequest struct {
	*requests.RpcRequest
	ProxyUserId string `position:"Query" name:"ProxyUserId"`
	ProductType string `position:"Query" name:"ProductType"`
}

// GetIntegrationTokenResponse is the response struct for api GetIntegrationToken
type GetIntegrationTokenResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Token     string `json:"Token" xml:"Token"`
}

// CreateGetIntegrationTokenRequest creates a request to invoke GetIntegrationToken API
func CreateGetIntegrationTokenRequest() (request *GetIntegrationTokenRequest) {
	request = &GetIntegrationTokenRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "GetIntegrationToken", "arms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetIntegrationTokenResponse creates a response to parse from GetIntegrationToken response
func CreateGetIntegrationTokenResponse() (response *GetIntegrationTokenResponse) {
	response = &GetIntegrationTokenResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
