package arms

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ImportPrometheusRules invokes the arms.ImportPrometheusRules API synchronously
func (client *Client) ImportPrometheusRules(request *ImportPrometheusRulesRequest) (response *ImportPrometheusRulesResponse, err error) {
	response = CreateImportPrometheusRulesResponse()
	err = client.DoAction(request, response)
	return
}

// ImportPrometheusRulesWithChan invokes the arms.ImportPrometheusRules API asynchronously
func (client *Client) ImportPrometheusRulesWithChan(request *ImportPrometheusRulesRequest) (<-chan *ImportPrometheusRulesResponse, <-chan error) {
	responseChan := make(chan *ImportPrometheusRulesResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ImportPrometheusRules(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ImportPrometheusRulesWithCallback invokes the arms.ImportPrometheusRules API asynchronously
func (client *Client) ImportPrometheusRulesWithCallback(request *ImportPrometheusRulesRequest, callback func(response *ImportPrometheusRulesResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ImportPrometheusRulesResponse
		var err error
		defer close(result)
		response, err = client.ImportPrometheusRules(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ImportPrometheusRulesRequest is the request struct for api ImportPrometheusRules
type ImportPrometheusRulesRequest struct {
	*requests.RpcRequest
	NameSpace string `position:"Query" name:"NameSpace"`
	Name      string `position:"Query" name:"Name"`
	ClusterId string `position:"Query" name:"ClusterId"`
	Content   string `position:"Query" name:"Content"`
}

// ImportPrometheusRulesResponse is the response struct for api ImportPrometheusRules
type ImportPrometheusRulesResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateImportPrometheusRulesRequest creates a request to invoke ImportPrometheusRules API
func CreateImportPrometheusRulesRequest() (request *ImportPrometheusRulesRequest) {
	request = &ImportPrometheusRulesRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ARMS", "2019-08-08", "ImportPrometheusRules", "arms", "openAPI")
	request.Method = requests.POST
	return
}

// CreateImportPrometheusRulesResponse creates a response to parse from ImportPrometheusRules response
func CreateImportPrometheusRulesResponse() (response *ImportPrometheusRulesResponse) {
	response = &ImportPrometheusRulesResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
