package ccc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetTurnCredentials invokes the ccc.GetTurnCredentials API synchronously
func (client *Client) GetTurnCredentials(request *GetTurnCredentialsRequest) (response *GetTurnCredentialsResponse, err error) {
	response = CreateGetTurnCredentialsResponse()
	err = client.DoAction(request, response)
	return
}

// GetTurnCredentialsWithChan invokes the ccc.GetTurnCredentials API asynchronously
func (client *Client) GetTurnCredentialsWithChan(request *GetTurnCredentialsRequest) (<-chan *GetTurnCredentialsResponse, <-chan error) {
	responseChan := make(chan *GetTurnCredentialsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetTurnCredentials(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetTurnCredentialsWithCallback invokes the ccc.GetTurnCredentials API asynchronously
func (client *Client) GetTurnCredentialsWithCallback(request *GetTurnCredentialsRequest, callback func(response *GetTurnCredentialsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetTurnCredentialsResponse
		var err error
		defer close(result)
		response, err = client.GetTurnCredentials(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetTurnCredentialsRequest is the request struct for api GetTurnCredentials
type GetTurnCredentialsRequest struct {
	*requests.RpcRequest
	UserId     string `position:"Query" name:"UserId"`
	InstanceId string `position:"Query" name:"InstanceId"`
}

// GetTurnCredentialsResponse is the response struct for api GetTurnCredentials
type GetTurnCredentialsResponse struct {
	*responses.BaseResponse
	Code           string   `json:"Code" xml:"Code"`
	HttpStatusCode int      `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string   `json:"Message" xml:"Message"`
	RequestId      string   `json:"RequestId" xml:"RequestId"`
	Params         []string `json:"Params" xml:"Params"`
	Data           Data     `json:"Data" xml:"Data"`
}

// CreateGetTurnCredentialsRequest creates a request to invoke GetTurnCredentials API
func CreateGetTurnCredentialsRequest() (request *GetTurnCredentialsRequest) {
	request = &GetTurnCredentialsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CCC", "2020-07-01", "GetTurnCredentials", "CCC", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetTurnCredentialsResponse creates a response to parse from GetTurnCredentials response
func CreateGetTurnCredentialsResponse() (response *GetTurnCredentialsResponse) {
	response = &GetTurnCredentialsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
