package ccc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RemovePhoneNumbersFromSkillGroup invokes the ccc.RemovePhoneNumbersFromSkillGroup API synchronously
func (client *Client) RemovePhoneNumbersFromSkillGroup(request *RemovePhoneNumbersFromSkillGroupRequest) (response *RemovePhoneNumbersFromSkillGroupResponse, err error) {
	response = CreateRemovePhoneNumbersFromSkillGroupResponse()
	err = client.DoAction(request, response)
	return
}

// RemovePhoneNumbersFromSkillGroupWithChan invokes the ccc.RemovePhoneNumbersFromSkillGroup API asynchronously
func (client *Client) RemovePhoneNumbersFromSkillGroupWithChan(request *RemovePhoneNumbersFromSkillGroupRequest) (<-chan *RemovePhoneNumbersFromSkillGroupResponse, <-chan error) {
	responseChan := make(chan *RemovePhoneNumbersFromSkillGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RemovePhoneNumbersFromSkillGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RemovePhoneNumbersFromSkillGroupWithCallback invokes the ccc.RemovePhoneNumbersFromSkillGroup API asynchronously
func (client *Client) RemovePhoneNumbersFromSkillGroupWithCallback(request *RemovePhoneNumbersFromSkillGroupRequest, callback func(response *RemovePhoneNumbersFromSkillGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RemovePhoneNumbersFromSkillGroupResponse
		var err error
		defer close(result)
		response, err = client.RemovePhoneNumbersFromSkillGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RemovePhoneNumbersFromSkillGroupRequest is the request struct for api RemovePhoneNumbersFromSkillGroup
type RemovePhoneNumbersFromSkillGroupRequest struct {
	*requests.RpcRequest
	NumberList   string `position:"Query" name:"NumberList"`
	InstanceId   string `position:"Query" name:"InstanceId"`
	SkillGroupId string `position:"Query" name:"SkillGroupId"`
}

// RemovePhoneNumbersFromSkillGroupResponse is the response struct for api RemovePhoneNumbersFromSkillGroup
type RemovePhoneNumbersFromSkillGroupResponse struct {
	*responses.BaseResponse
	Code           string `json:"Code" xml:"Code"`
	HttpStatusCode int    `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string `json:"Message" xml:"Message"`
	RequestId      string `json:"RequestId" xml:"RequestId"`
}

// CreateRemovePhoneNumbersFromSkillGroupRequest creates a request to invoke RemovePhoneNumbersFromSkillGroup API
func CreateRemovePhoneNumbersFromSkillGroupRequest() (request *RemovePhoneNumbersFromSkillGroupRequest) {
	request = &RemovePhoneNumbersFromSkillGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CCC", "2020-07-01", "RemovePhoneNumbersFromSkillGroup", "CCC", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRemovePhoneNumbersFromSkillGroupResponse creates a response to parse from RemovePhoneNumbersFromSkillGroup response
func CreateRemovePhoneNumbersFromSkillGroupResponse() (response *RemovePhoneNumbersFromSkillGroupResponse) {
	response = &RemovePhoneNumbersFromSkillGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
