package ccc

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ResetAgentState invokes the ccc.ResetAgentState API synchronously
func (client *Client) ResetAgentState(request *ResetAgentStateRequest) (response *ResetAgentStateResponse, err error) {
	response = CreateResetAgentStateResponse()
	err = client.DoAction(request, response)
	return
}

// ResetAgentStateWithChan invokes the ccc.ResetAgentState API asynchronously
func (client *Client) ResetAgentStateWithChan(request *ResetAgentStateRequest) (<-chan *ResetAgentStateResponse, <-chan error) {
	responseChan := make(chan *ResetAgentStateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ResetAgentState(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ResetAgentStateWithCallback invokes the ccc.ResetAgentState API asynchronously
func (client *Client) ResetAgentStateWithCallback(request *ResetAgentStateRequest, callback func(response *ResetAgentStateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ResetAgentStateResponse
		var err error
		defer close(result)
		response, err = client.ResetAgentState(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ResetAgentStateRequest is the request struct for api ResetAgentState
type ResetAgentStateRequest struct {
	*requests.RpcRequest
	UserId     string `position:"Query" name:"UserId"`
	DeviceId   string `position:"Query" name:"DeviceId"`
	InstanceId string `position:"Query" name:"InstanceId"`
}

// ResetAgentStateResponse is the response struct for api ResetAgentState
type ResetAgentStateResponse struct {
	*responses.BaseResponse
	Code           string   `json:"Code" xml:"Code"`
	HttpStatusCode int      `json:"HttpStatusCode" xml:"HttpStatusCode"`
	Message        string   `json:"Message" xml:"Message"`
	RequestId      string   `json:"RequestId" xml:"RequestId"`
	Params         []string `json:"Params" xml:"Params"`
	Data           Data     `json:"Data" xml:"Data"`
}

// CreateResetAgentStateRequest creates a request to invoke ResetAgentState API
func CreateResetAgentStateRequest() (request *ResetAgentStateRequest) {
	request = &ResetAgentStateRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("CCC", "2020-07-01", "ResetAgentState", "CCC", "openAPI")
	request.Method = requests.POST
	return
}

// CreateResetAgentStateResponse creates a response to parse from ResetAgentState response
func CreateResetAgentStateResponse() (response *ResetAgentStateResponse) {
	response = &ResetAgentStateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
