package dts

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeJobDiffStatus invokes the dts.DescribeJobDiffStatus API synchronously
func (client *Client) DescribeJobDiffStatus(request *DescribeJobDiffStatusRequest) (response *DescribeJobDiffStatusResponse, err error) {
	response = CreateDescribeJobDiffStatusResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeJobDiffStatusWithChan invokes the dts.DescribeJobDiffStatus API asynchronously
func (client *Client) DescribeJobDiffStatusWithChan(request *DescribeJobDiffStatusRequest) (<-chan *DescribeJobDiffStatusResponse, <-chan error) {
	responseChan := make(chan *DescribeJobDiffStatusResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeJobDiffStatus(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeJobDiffStatusWithCallback invokes the dts.DescribeJobDiffStatus API asynchronously
func (client *Client) DescribeJobDiffStatusWithCallback(request *DescribeJobDiffStatusRequest, callback func(response *DescribeJobDiffStatusResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeJobDiffStatusResponse
		var err error
		defer close(result)
		response, err = client.DescribeJobDiffStatus(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeJobDiffStatusRequest is the request struct for api DescribeJobDiffStatus
type DescribeJobDiffStatusRequest struct {
	*requests.RpcRequest
	PageNumber string `position:"Query" name:"PageNumber"`
	TbName     string `position:"Query" name:"TbName"`
	DbName     string `position:"Query" name:"DbName"`
	PageSize   string `position:"Query" name:"PageSize"`
	DtsJobId   string `position:"Query" name:"DtsJobId"`
}

// DescribeJobDiffStatusResponse is the response struct for api DescribeJobDiffStatus
type DescribeJobDiffStatusResponse struct {
	*responses.BaseResponse
	DynamicCode    string          `json:"DynamicCode" xml:"DynamicCode"`
	DynamicMessage string          `json:"DynamicMessage" xml:"DynamicMessage"`
	ErrCode        string          `json:"ErrCode" xml:"ErrCode"`
	ErrMessage     string          `json:"ErrMessage" xml:"ErrMessage"`
	HttpStatusCode int             `json:"HttpStatusCode" xml:"HttpStatusCode"`
	RequestId      string          `json:"RequestId" xml:"RequestId"`
	Success        bool            `json:"Success" xml:"Success"`
	Total          int64           `json:"Total" xml:"Total"`
	DiffInfos      []DiffInfosItem `json:"DiffInfos" xml:"DiffInfos"`
}

// CreateDescribeJobDiffStatusRequest creates a request to invoke DescribeJobDiffStatus API
func CreateDescribeJobDiffStatusRequest() (request *DescribeJobDiffStatusRequest) {
	request = &DescribeJobDiffStatusRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Dts", "2020-01-01", "DescribeJobDiffStatus", "dts", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeJobDiffStatusResponse creates a response to parse from DescribeJobDiffStatus response
func CreateDescribeJobDiffStatusResponse() (response *DescribeJobDiffStatusResponse) {
	response = &DescribeJobDiffStatusResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
