package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AddACLRule invokes the smartag.AddACLRule API synchronously
func (client *Client) AddACLRule(request *AddACLRuleRequest) (response *AddACLRuleResponse, err error) {
	response = CreateAddACLRuleResponse()
	err = client.DoAction(request, response)
	return
}

// AddACLRuleWithChan invokes the smartag.AddACLRule API asynchronously
func (client *Client) AddACLRuleWithChan(request *AddACLRuleRequest) (<-chan *AddACLRuleResponse, <-chan error) {
	responseChan := make(chan *AddACLRuleResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AddACLRule(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AddACLRuleWithCallback invokes the smartag.AddACLRule API asynchronously
func (client *Client) AddACLRuleWithCallback(request *AddACLRuleRequest, callback func(response *AddACLRuleResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AddACLRuleResponse
		var err error
		defer close(result)
		response, err = client.AddACLRule(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AddACLRuleRequest is the request struct for api AddACLRule
type AddACLRuleRequest struct {
	*requests.RpcRequest
	DpiGroupIds          *[]string        `position:"Query" name:"DpiGroupIds"  type:"Repeated"`
	ResourceOwnerId      requests.Integer `position:"Query"`
	SourcePortRange      string           `position:"Query"`
	SourceCidr           string           `position:"Query"`
	Description          string           `position:"Query"`
	Type                 string           `position:"Query"`
	DestCidr             string           `position:"Query"`
	DpiSignatureIds      *[]string        `position:"Query" name:"DpiSignatureIds"  type:"Repeated"`
	Direction            string           `position:"Query"`
	Policy               string           `position:"Query"`
	AclId                string           `position:"Query"`
	ResourceOwnerAccount string           `position:"Query"`
	IpProtocol           string           `position:"Query"`
	OwnerAccount         string           `position:"Query"`
	OwnerId              requests.Integer `position:"Query"`
	Priority             requests.Integer `position:"Query"`
	DestPortRange        string           `position:"Query"`
	Name                 string           `position:"Query"`
}

// AddACLRuleResponse is the response struct for api AddACLRule
type AddACLRuleResponse struct {
	*responses.BaseResponse
	Policy          string                      `json:"Policy" xml:"Policy"`
	Description     string                      `json:"Description" xml:"Description"`
	SourcePortRange string                      `json:"SourcePortRange" xml:"SourcePortRange"`
	RequestId       string                      `json:"RequestId" xml:"RequestId"`
	SourceCidr      string                      `json:"SourceCidr" xml:"SourceCidr"`
	Priority        int                         `json:"Priority" xml:"Priority"`
	AclId           string                      `json:"AclId" xml:"AclId"`
	AcrId           string                      `json:"AcrId" xml:"AcrId"`
	DestPortRange   string                      `json:"DestPortRange" xml:"DestPortRange"`
	Direction       string                      `json:"Direction" xml:"Direction"`
	Name            string                      `json:"Name" xml:"Name"`
	GmtCreate       int64                       `json:"GmtCreate" xml:"GmtCreate"`
	Type            string                      `json:"Type" xml:"Type"`
	DestCidr        string                      `json:"DestCidr" xml:"DestCidr"`
	IpProtocol      string                      `json:"IpProtocol" xml:"IpProtocol"`
	DpiSignatureIds DpiSignatureIdsInAddACLRule `json:"DpiSignatureIds" xml:"DpiSignatureIds"`
	DpiGroupIds     DpiGroupIdsInAddACLRule     `json:"DpiGroupIds" xml:"DpiGroupIds"`
}

// CreateAddACLRuleRequest creates a request to invoke AddACLRule API
func CreateAddACLRuleRequest() (request *AddACLRuleRequest) {
	request = &AddACLRuleRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "AddACLRule", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateAddACLRuleResponse creates a response to parse from AddACLRule response
func CreateAddACLRuleResponse() (response *AddACLRuleResponse) {
	response = &AddACLRuleResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
