package smartag

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetSagRouteableAddress invokes the smartag.SetSagRouteableAddress API synchronously
func (client *Client) SetSagRouteableAddress(request *SetSagRouteableAddressRequest) (response *SetSagRouteableAddressResponse, err error) {
	response = CreateSetSagRouteableAddressResponse()
	err = client.DoAction(request, response)
	return
}

// SetSagRouteableAddressWithChan invokes the smartag.SetSagRouteableAddress API asynchronously
func (client *Client) SetSagRouteableAddressWithChan(request *SetSagRouteableAddressRequest) (<-chan *SetSagRouteableAddressResponse, <-chan error) {
	responseChan := make(chan *SetSagRouteableAddressResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetSagRouteableAddress(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetSagRouteableAddressWithCallback invokes the smartag.SetSagRouteableAddress API asynchronously
func (client *Client) SetSagRouteableAddressWithCallback(request *SetSagRouteableAddressRequest, callback func(response *SetSagRouteableAddressResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetSagRouteableAddressResponse
		var err error
		defer close(result)
		response, err = client.SetSagRouteableAddress(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetSagRouteableAddressRequest is the request struct for api SetSagRouteableAddress
type SetSagRouteableAddressRequest struct {
	*requests.RpcRequest
	AccessKeyId          string           `position:"Query"`
	ResourceOwnerId      requests.Integer `position:"Query"`
	RouteableAddress     string           `position:"Query"`
	ResourceOwnerAccount string           `position:"Query"`
	OwnerAccount         string           `position:"Query"`
	OwnerId              requests.Integer `position:"Query"`
	SagId                string           `position:"Query"`
}

// SetSagRouteableAddressResponse is the response struct for api SetSagRouteableAddress
type SetSagRouteableAddressResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateSetSagRouteableAddressRequest creates a request to invoke SetSagRouteableAddress API
func CreateSetSagRouteableAddressRequest() (request *SetSagRouteableAddressRequest) {
	request = &SetSagRouteableAddressRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Smartag", "2018-03-13", "SetSagRouteableAddress", "smartag", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSetSagRouteableAddressResponse creates a response to parse from SetSagRouteableAddress response
func CreateSetSagRouteableAddressResponse() (response *SetSagRouteableAddressResponse) {
	response = &SetSagRouteableAddressResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
